/*
 * Action.java
 *
 * 作成日: 2008/09/20
 * Copyright(C)2008 Kyushu Institute of Technology., All right reserved. 
 */
package jp.ac.kyutech.SRP.Scripting;

import RTC.ReturnCode_t;

/**
 * SDLEngine をサポートした Consumer な RTC で動作する処理を
 * 登録するためのコールバックインターフェイスです。
 *
 * @author 
 */
public interface Action {

    /**
     * RTC で動作する処理を記述します。
     * @param component 処理の対象となる{@link jp.go.aist.rtm.RTC.RTObject_impl}です
     * @param ec_id 
     * @return
     */
    public ReturnCode_t execute(Object component, int ec_id);
    
    /**
     * ロックオブジェクトを取得します。
     * アクションの終了時にこのロックオブジェクトに対して、{@link Object#notify()}を実行します。
     * @return
     */
    public Object getLock();
    
}
