package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/CollisionDetectorPOA.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/CollisionDetector.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
   * @if jp
   * CollisionDetector インターフェース
   *
   * このサーバは衝突検出とその法線ベクトルの算出を行います。
   * 通常、 DynamicsSimulator から呼び出されるため、直接このサーバにアクセスする必要はありません。
   * @endif
   */
public abstract class CollisionDetectorPOA extends org.omg.PortableServer.Servant
 implements jp.go.aist.hrp.simulator.CollisionDetectorOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("destroy", new java.lang.Integer (0));
    _methods.put ("addModel", new java.lang.Integer (1));
    _methods.put ("addCollisionPair", new java.lang.Integer (2));
    _methods.put ("removeCollisionPair", new java.lang.Integer (3));
    _methods.put ("queryIntersectionForDefinedPairs", new java.lang.Integer (4));
    _methods.put ("queryIntersectionForGivenPairs", new java.lang.Integer (5));
    _methods.put ("queryContactDeterminationForDefinedPairs", new java.lang.Integer (6));
    _methods.put ("queryContactDeterminationForGivenPairs", new java.lang.Integer (7));
    _methods.put ("clearCache", new java.lang.Integer (8));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {
       case 0:  // OpenHRP/CollisionDetector/destroy
       {
         this.destroy ();
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * @brief キャラクタを追加します。
       * @param   charName    キャラクタ名
       * @param   model	    モデル情報
       * @else
       * Adding Objects
       * @param   charName    Character Name
       * @param   model	    model information
       * @endif
      */
       case 1:  // OpenHRP/CollisionDetector/addModel
       {
         String charName = in.read_string ();
         jp.go.aist.hrp.simulator.CharacterInfo model = jp.go.aist.hrp.simulator.CharacterInfoHelper.read (in);
         this.addModel (charName, model);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * @brief 干渉チェックペアを追加します。
       * @param   colPair       干渉チェックペア
       * @param   convexsize1   ペアのうち、1つ目を凸包集合に変換するか
       * @param   convexsize2   ペアのうち、2つ目を凸包集合に変換するか
       * @else
       * Adding Polygon Set Pairs
       * @param   colPair       Collision Pair
       * @param   convexsize1   Flag to set whether object1 
       *  			      should be converted to a set of Convexes
       * @param   convexsize2   Flag to set whether object2
       * 			      should be converted to a set of Convexes
       * @endif
      */
       case 2:  // OpenHRP/CollisionDetector/addCollisionPair
       {
         jp.go.aist.hrp.simulator.LinkPair colPair = jp.go.aist.hrp.simulator.LinkPairHelper.read (in);
         boolean convexsize1 = in.read_boolean ();
         boolean convexsize2 = in.read_boolean ();
         this.addCollisionPair (colPair, convexsize1, convexsize2);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * @brief ペアを取り除きます。
       * @param colPair 取り除くペア
       * @else
       * Delete a pair of Polygon Sets
       * @param   colPair       Collision Pair
       * @endif
       */
       case 3:  // OpenHRP/CollisionDetector/removeCollisionPair
       {
         jp.go.aist.hrp.simulator.LinkPair colPair = jp.go.aist.hrp.simulator.LinkPairHelper.read (in);
         this.removeCollisionPair (colPair);
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * 既に設定されたペアから衝突検出を行います。
       * @param checkAll 全てをチェックするか(falseを設定するとひとつ衝突を検出した時点で終了します)
       * @param positions キャラクタの位置/姿勢
       * @param collidedPairs 衝突しているペアの配列(衝突していなければ長さは0)
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Check for Collision between pre-defined Pairs
       * @param  checkAll     true:  Check All Pairs
       * 		  false: Stop when 1 collision is found
       * @param  characters    Position and Attitude of Object
       * @param  collidedPairs  Array of Pairs that are colliding(If none length is 0)
       * @return true:  At least one pair is colliding
       *      false: No pairs are colliding
       * @endif
       */
       case 4:  // OpenHRP/CollisionDetector/queryIntersectionForDefinedPairs
       {
         boolean checkAll = in.read_boolean ();
         jp.go.aist.hrp.simulator.CharacterPosition positions[] = jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.read (in);
         jp.go.aist.hrp.simulator.LinkPairSequenceHolder collidedPairs = new jp.go.aist.hrp.simulator.LinkPairSequenceHolder ();
         boolean $result = false;
         $result = this.queryIntersectionForDefinedPairs (checkAll, positions, collidedPairs);
         out = $rh.createReply();
         out.write_boolean ($result);
         jp.go.aist.hrp.simulator.LinkPairSequenceHelper.write (out, collidedPairs.value);
         break;
       }


  /**
       * @if jp
       * ペアを設定し衝突検出を行います。
       * @param checkAll 全てのペアをチェックするか(falseを設定するとひとつ衝突を検出した時点で終了します)
       * @param checkPairs ペア
       * @param positions キャラクタの位置/姿勢
       * @param collidedPairs 衝突しているペアの配列(衝突していなければ長さは0)
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Check for Collision between Given Pairs
       *    
       * @param  checkAll     true:  Check All Pairs
       *                     false: Return when 1 collision is found
       * @param  checkPairs   Array of Pairs to check for Collision
       * @param  characters    Position and Attitude of Object
       * @param  collidedPairs  Array of Pairs that are colliding(If none length is 0)
       * @return true:  At least one pair is colliding
       *         false: No pairs are colliding
       * @endif
       */
       case 5:  // OpenHRP/CollisionDetector/queryIntersectionForGivenPairs
       {
         boolean checkAll = in.read_boolean ();
         jp.go.aist.hrp.simulator.LinkPair checkPairs[] = jp.go.aist.hrp.simulator.LinkPairSequenceHelper.read (in);
         jp.go.aist.hrp.simulator.CharacterPosition positions[] = jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.read (in);
         jp.go.aist.hrp.simulator.LinkPairSequenceHolder collidedPairs = new jp.go.aist.hrp.simulator.LinkPairSequenceHolder ();
         boolean $result = false;
         $result = this.queryIntersectionForGivenPairs (checkAll, checkPairs, positions, collidedPairs);
         out = $rh.createReply();
         out.write_boolean ($result);
         jp.go.aist.hrp.simulator.LinkPairSequenceHelper.write (out, collidedPairs.value);
         break;
       }


  /**
       * @if jp
       * すでに設定したペアの衝突情報を取得します。
       * @param characters キャラクタの位置/姿勢
       * @param colInfos 衝突情報
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Get Collision State Information of pre-defined Pairs
       *
       * @param  characters    Position of Object
       * @param  colInfos     Collision Information
       * @return true:        At least one pair is colliding
       *         false:       No pairs are colliding
       * @endif
       */
       case 6:  // OpenHRP/CollisionDetector/queryContactDeterminationForDefinedPairs
       {
         jp.go.aist.hrp.simulator.CharacterPosition positions[] = jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.read (in);
         jp.go.aist.hrp.simulator.CollisionSequenceHolder collisions = new jp.go.aist.hrp.simulator.CollisionSequenceHolder ();
         boolean $result = false;
         $result = this.queryContactDeterminationForDefinedPairs (positions, collisions);
         out = $rh.createReply();
         out.write_boolean ($result);
         jp.go.aist.hrp.simulator.CollisionSequenceHelper.write (out, collisions.value);
         break;
       }


  /**
       * @if jp
       * ペアを与え衝突情報を取得します。
       * @param checkPairs ペア
       * @param characters キャラクタの位置/姿勢
       * @param colInfos 衝突情報
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Get Collision State Information for given Pairs
       *
       * @param  checkPairs   Array of pairs to check for collision
       * @param  characters    Position of Object
       * @param  colInfos     Collision Information
       * @return true:        At least one pair is colliding
       *         false:       No pairs are colliding
       * @endif
       */
       case 7:  // OpenHRP/CollisionDetector/queryContactDeterminationForGivenPairs
       {
         jp.go.aist.hrp.simulator.LinkPair checkPairs[] = jp.go.aist.hrp.simulator.LinkPairSequenceHelper.read (in);
         jp.go.aist.hrp.simulator.CharacterPosition positions[] = jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.read (in);
         jp.go.aist.hrp.simulator.CollisionSequenceHolder collisions = new jp.go.aist.hrp.simulator.CollisionSequenceHolder ();
         boolean $result = false;
         $result = this.queryContactDeterminationForGivenPairs (checkPairs, positions, collisions);
         out = $rh.createReply();
         out.write_boolean ($result);
         jp.go.aist.hrp.simulator.CollisionSequenceHelper.write (out, collisions.value);
         break;
       }


  /**
       * @if jp
       * キャッシュをクリアします。
       * @param url モデルファイルURL
       * @else
       * Clear the Cache
       * @param   url         Data Identifier
       * @endif
       */
       case 8:  // OpenHRP/CollisionDetector/clearCache
       {
         String url = in.read_string ();
         this.clearCache (url);
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/CollisionDetector:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public CollisionDetector _this() 
  {
    return CollisionDetectorHelper.narrow(
    super._this_object());
  }

  public CollisionDetector _this(org.omg.CORBA.ORB orb) 
  {
    return CollisionDetectorHelper.narrow(
    super._this_object(orb));
  }


} // class CollisionDetectorPOA
