package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/ControllerPOA.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/Controller.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
	 * @if jp
	 * @brief Controller インターフェース。
	 *
	 * 制御ソフトの役割を果たします。 Controller は以下の流れを行うように作成してください。
	 *
	 * -# コンストラクタで起動時の初期化
	 * -# start() でシミュレーション開始時の初期化
	 * -# input() でシミュレータからセンサ情報を得る
	 * -# control() センサ情報から制御計算を行う
	 * -# output() でアクチュエータに情報をセットする
	 * 
	 * @note 今後OpenHRPのコントローラはOpenRTMのコンポーネントとして作成するのが標準となります。
	 * 従って、一般的な使用においては本インタフェースを直接使う必要はありません。
	 *
	 * @else
	 * Controller Interface
	 * @endif
	 */
public abstract class ControllerPOA extends org.omg.PortableServer.Servant
 implements jp.go.aist.hrp.simulator.ControllerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("setDynamicsSimulator", new java.lang.Integer (0));
    _methods.put ("setViewSimulator", new java.lang.Integer (1));
    _methods.put ("start", new java.lang.Integer (2));
    _methods.put ("control", new java.lang.Integer (3));
    _methods.put ("input", new java.lang.Integer (4));
    _methods.put ("output", new java.lang.Integer (5));
    _methods.put ("stop", new java.lang.Integer (6));
    _methods.put ("destroy", new java.lang.Integer (7));
    _methods.put ("setTimeStep", new java.lang.Integer (8));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
  		 * @if jp
  		 * @brief DynamicsSimulator をセットする。
  		 *
  		 * クライアントが Controller サーバを使用する際、 DynamicsSimulator への参照をセットします。
  		 * @param dynamicssimulator_ DynamicsSimulator への参照
  		 * @endif
  		 */
       case 0:  // OpenHRP/Controller/setDynamicsSimulator
       {
         jp.go.aist.hrp.simulator.DynamicsSimulator dynamicssimulator_ = jp.go.aist.hrp.simulator.DynamicsSimulatorHelper.read (in);
         this.setDynamicsSimulator (dynamicssimulator_);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief ViewSimulatorをセットする。
  		 *
  		 * setDynamicsSimulator() と同様に ViewSimulator を使用する Controller に
  		 * 接続する際はこのメソッドでセットします。
  		 *
  		 * @param viewsimulator_ ViewSimulator への参照
  		 * @endif
  		 */
       case 1:  // OpenHRP/Controller/setViewSimulator
       {
         jp.go.aist.hrp.simulator.ViewSimulator viewsimulator_ = jp.go.aist.hrp.simulator.ViewSimulatorHelper.read (in);
         this.setViewSimulator (viewsimulator_);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief シミュレーションループが始まる前に１回呼ばれます。
  		 *
  		 * シミュレーション前の初期化はここに書いてください。
  		 * @else
  		 * This method is called just before beginning periodic calls of control().
  		 *
  		 * Initialization that requires the initial state of a robot
  		 * should be done in this method.
  		 * @endif
  		 */
       case 2:  // OpenHRP/Controller/start
       {
         this.start ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 制御計算を行います。
  		 *
  		 * シミュレーションループにおいて input() で取得した情報を使用して計算を行い、 output() で出力します。
  		 * @endif
  		 */
       case 3:  // OpenHRP/Controller/control
       {
         this.control ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief センサ情報の取得を行います。
  		 *
  		 * DynamicsSimulator::getCharacterSensorState() 等を使用してセンサ情報を取得します。
  		 * @endif
  		 */
       case 4:  // OpenHRP/Controller/input
       {
         this.input ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief アクチュエータなどへ情報を出力します。
  		 *
  		 * DynamicsSimulator::setCharacterLinkData() 等を使用してシミュレータへ情報を出力します。
  		 * @endif
  		 */
       case 5:  // OpenHRP/Controller/output
       {
         this.output ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * シミュレーションループが終了した際に呼ばれます。
  		 * @else
  		 * This method is called when the control loop is finished.
  		 * @endif
  		 */
       case 6:  // OpenHRP/Controller/stop
       {
         this.stop ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * サーバを終了します。
  		 * @endif
  		 */
       case 7:  // OpenHRP/Controller/destroy
       {
         this.destroy ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * controllerのtimeStepを設定します。
  		 * @endif
  		 */
       case 8:  // OpenHRP/Controller/setTimeStep
       {
         double timeStep = in.read_double ();
         this.setTimeStep (timeStep);
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/Controller:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public Controller _this() 
  {
    return ControllerHelper.narrow(
    super._this_object());
  }

  public Controller _this(org.omg.CORBA.ORB orb) 
  {
    return ControllerHelper.narrow(
    super._this_object(orb));
  }


} // class ControllerPOA
