package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/DynamicsSimulatorHelper.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/DynamicsSimulator.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
	 * @if jp
	 * @brief DynamicsSimulator インターフェース
	 *
	 * 力学シミュレーションを行うサーバです。使用する際は以下の流れで行います。
	 *
	 * -# DynamicsSimulatorFactory の参照を取得
	 * -# DynamicsSimulatorFactory::create() で DynamicsSimulator を取得
	 * -# registerCharacter() でキャラクタを登録
	 * -# init() でシミュレーションの設定
	 * -# setGVector() で重力ベクトルの設定
	 * -# setCharacterAllJointModes() で関節駆動モードの設定
	 * -# setCharacterAllLinkData() で初期姿勢を与え、 calcWorldForwardKinematics() を実行し順運動学を１回実行
	 * -# registerCollisionCheckPair() をどの関節/キャラクタに対して干渉チェックを実行するかを設定する
	 * -# initSimulation() でサーバの初期化
	 *
	 * 以下、シミュレーションループ
	 *
	 * -# stepSimulation() でシミュレーションを1ステップ実行
	 * -# getWorldState() で現在の状況を取得
	 * @else
	 * Dynamics Server
	 *
	 * @date	2006.02.02
	 * @version	pre2.0 
	 * modified	2006.02.24 some functions needed to specify character name
	 * @endif
	 */
abstract public class DynamicsSimulatorHelper
{
  private static String  _id = "IDL:OpenHRP/DynamicsSimulator:1.0";

  public static void insert (org.omg.CORBA.Any a, jp.go.aist.hrp.simulator.DynamicsSimulator that)
  {
    org.omg.CORBA.portable.OutputStream out = a.create_output_stream ();
    a.type (type ());
    write (out, that);
    a.read_value (out.create_input_stream (), type ());
  }

  public static jp.go.aist.hrp.simulator.DynamicsSimulator extract (org.omg.CORBA.Any a)
  {
    return read (a.create_input_stream ());
  }

  private static org.omg.CORBA.TypeCode __typeCode = null;
  synchronized public static org.omg.CORBA.TypeCode type ()
  {
    if (__typeCode == null)
    {
      __typeCode = org.omg.CORBA.ORB.init ().create_interface_tc (jp.go.aist.hrp.simulator.DynamicsSimulatorHelper.id (), "DynamicsSimulator");
    }
    return __typeCode;
  }

  public static String id ()
  {
    return _id;
  }

  public static jp.go.aist.hrp.simulator.DynamicsSimulator read (org.omg.CORBA.portable.InputStream istream)
  {
    return narrow (istream.read_Object (_DynamicsSimulatorStub.class));
  }

  public static void write (org.omg.CORBA.portable.OutputStream ostream, jp.go.aist.hrp.simulator.DynamicsSimulator value)
  {
    ostream.write_Object ((org.omg.CORBA.Object) value);
  }

  public static jp.go.aist.hrp.simulator.DynamicsSimulator narrow (org.omg.CORBA.Object obj)
  {
    if (obj == null)
      return null;
    else if (obj instanceof jp.go.aist.hrp.simulator.DynamicsSimulator)
      return (jp.go.aist.hrp.simulator.DynamicsSimulator)obj;
    else if (!obj._is_a (id ()))
      throw new org.omg.CORBA.BAD_PARAM ();
    else
    {
      org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate ();
      jp.go.aist.hrp.simulator._DynamicsSimulatorStub stub = new jp.go.aist.hrp.simulator._DynamicsSimulatorStub ();
      stub._set_delegate(delegate);
      return stub;
    }
  }

  public static jp.go.aist.hrp.simulator.DynamicsSimulator unchecked_narrow (org.omg.CORBA.Object obj)
  {
    if (obj == null)
      return null;
    else if (obj instanceof jp.go.aist.hrp.simulator.DynamicsSimulator)
      return (jp.go.aist.hrp.simulator.DynamicsSimulator)obj;
    else
    {
      org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate ();
      jp.go.aist.hrp.simulator._DynamicsSimulatorStub stub = new jp.go.aist.hrp.simulator._DynamicsSimulatorStub ();
      stub._set_delegate(delegate);
      return stub;
    }
  }

}
