package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/ModelLoaderPOA.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/ModelLoader.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * @brief ModelLoader インタフェース定義です。
   *
   * テキスト記述されたモデル情報を読み込み、オブジェクトとして提供します。
   * クライアントからは load() して CharacterInfo を取得し、それを DynamicsSimulator等に登録します。
   * @endif
   * @author  Keisuke Saito, KernelInc
   */
public abstract class ModelLoaderPOA extends org.omg.PortableServer.Servant
 implements jp.go.aist.hrp.simulator.ModelLoaderOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("loadURL", new java.lang.Integer (0));
    _methods.put ("reloadURL", new java.lang.Integer (1));
    _methods.put ("clearData", new java.lang.Integer (2));
    _methods.put ("shutdown", new java.lang.Integer (3));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
       * @if jp
       * ファイルからロードします。
       * @param   url                 ファイルのURL
       * @return  情報を保持したオブジェクト
       * @endif
       */
       case 0:  // OpenHRP/ModelLoader/loadURL
       {
         try {
           String url = in.read_string ();
           jp.go.aist.hrp.simulator.CharacterInfo $result = null;
           $result = this.loadURL (url);
           out = $rh.createReply();
           jp.go.aist.hrp.simulator.CharacterInfoHelper.write (out, $result);
         } catch (jp.go.aist.hrp.simulator.ModelLoaderPackage.ModelLoaderException $ex) {
           out = $rh.createExceptionReply ();
           jp.go.aist.hrp.simulator.ModelLoaderPackage.ModelLoaderExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
       * @if jp
       * ファイルからキャッシュを使わずにロード します。
       * @param   url                 ファイルのURL
       * @return  情報を保持したオブジェクト
       * @endif
       */
       case 1:  // OpenHRP/ModelLoader/reloadURL
       {
         try {
           String url = in.read_string ();
           jp.go.aist.hrp.simulator.CharacterInfo $result = null;
           $result = this.reloadURL (url);
           out = $rh.createReply();
           jp.go.aist.hrp.simulator.CharacterInfoHelper.write (out, $result);
         } catch (jp.go.aist.hrp.simulator.ModelLoaderPackage.ModelLoaderException $ex) {
           out = $rh.createExceptionReply ();
           jp.go.aist.hrp.simulator.ModelLoaderPackage.ModelLoaderExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
       * @if jp
       * キャッシュをクリアします。
       * @endif
       */
       case 2:  // OpenHRP/ModelLoader/clearData
       {
         this.clearData ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * 終了
  		 * @endif
  		 */
       case 3:  // OpenHRP/ServerObject/shutdown
       {
         this.shutdown ();
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/ModelLoader:1.0", 
    "IDL:OpenHRP/ServerObject:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public ModelLoader _this() 
  {
    return ModelLoaderHelper.narrow(
    super._this_object());
  }

  public ModelLoader _this(org.omg.CORBA.ORB orb) 
  {
    return ModelLoaderHelper.narrow(
    super._this_object(orb));
  }


} // class ModelLoaderPOA
