package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/ViewSimulatorPOA.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/ViewSimulator.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * @brief ViewSimulator インターフェース
   *
   * カメラとそれから取得できる画像をシミュレーションします。
   *
   * Controllerからは以下の手順で使用できます。
   * メンバ visionSensor_ にセットされた ViewSimulator に対して、
   * 
   * -# ViewSimulator::getCameraSequenceOf を使用して Camera を取得します。
   * -# Camera::getCameraParameter から取得される CameraParameter で各種情報を調べます。
   *
   * 以下、シミュレーションループ
   *
   * -# Camera::getImageData で ImageDataを取得します。
   * -# このカメラのフォーマットにしたがい、ImageData::longData 等から画像を取得します。
   *
   * @author	Ichitaro Kohara, MSTC
   * @version	1.0(2001.02.22)
   * @else
   * Vision Sensor
   * @author	Ichitaro Kohara, MSTC
   * @version	1.0(2001.02.22)
   * @endif
   */
public abstract class ViewSimulatorPOA extends org.omg.PortableServer.Servant
 implements jp.go.aist.hrp.simulator.ViewSimulatorOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("destroy", new java.lang.Integer (0));
    _methods.put ("loadObject", new java.lang.Integer (1));
    _methods.put ("getCameraSequence", new java.lang.Integer (2));
    _methods.put ("getCameraSequenceOf", new java.lang.Integer (3));
    _methods.put ("updateScene", new java.lang.Integer (4));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
       * @if jp
       * サーバを終了します。
       * @else
       * Destory
       * @endif
       */
       case 0:  // OpenHRP/ViewSimulator/destroy
       {
         this.destroy ();
         out = $rh.createReply();
         break;
       }


  /**
       * @if jp
       * モデルを読み込みます。
       * @param src キャラクタのモデルファイルURL
       * @param objectName キャラクタ名
       * @else
       * Loat object
       * @param	src			object's URL
       * @param	objectName	object's Name
       * @endif
       */
       case 1:  // OpenHRP/ViewSimulator/loadObject
       {
         try {
           String src = in.read_string ();
           String objectName = in.read_string ();
           this.loadObject (src, objectName);
           out = $rh.createReply();
         } catch (jp.go.aist.hrp.simulator.ViewSimulatorPackage.ViewSimulatorException $ex) {
           out = $rh.createExceptionReply ();
           jp.go.aist.hrp.simulator.ViewSimulatorPackage.ViewSimulatorExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
       * @if jp
       * シミュレータにあるカメラを取得します。
       * @param cameras カメラ配列
       * @return カメラの台数
       * @else
       * Get cameras loaded in simulator
       * @param	cameras		cameras
       * @return	number of cameras
       * @endif
       */
       case 2:  // OpenHRP/ViewSimulator/getCameraSequence
       {
         jp.go.aist.hrp.simulator.CameraSequenceHolder cameras = new jp.go.aist.hrp.simulator.CameraSequenceHolder ();
         this.getCameraSequence (cameras);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.CameraSequenceHelper.write (out, cameras.value);
         break;
       }


  /**
       * @if jp
       * キャラクタにあるカメラを取得します。
       * @param objectName キャラクタ名
       * @param cameras カメラ配列
       * @endif
       */
       case 3:  // OpenHRP/ViewSimulator/getCameraSequenceOf
       {
         String objectName = in.read_string ();
         jp.go.aist.hrp.simulator.CameraSequenceHolder cameras = new jp.go.aist.hrp.simulator.CameraSequenceHolder ();
         this.getCameraSequenceOf (objectName, cameras);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.CameraSequenceHelper.write (out, cameras.value);
         break;
       }


  /**
       * @if jp
       * シーンを更新します。
       * @param state 新しい WorldState
       * @else
       * Update scene
       * @param	state	WorldState
       * @endif
       */
       case 4:  // OpenHRP/ViewSimulator/updateScene
       {
         jp.go.aist.hrp.simulator.WorldState state = jp.go.aist.hrp.simulator.WorldStateHelper.read (in);
         this.updateScene (state);
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/ViewSimulator:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public ViewSimulator _this() 
  {
    return ViewSimulatorHelper.narrow(
    super._this_object());
  }

  public ViewSimulator _this(org.omg.CORBA.ORB orb) 
  {
    return ViewSimulatorHelper.narrow(
    super._this_object(orb));
  }


} // class ViewSimulatorPOA
