package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/_ViewSimulatorStub.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/ViewSimulator.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * @brief ViewSimulator インターフェース
   *
   * カメラとそれから取得できる画像をシミュレーションします。
   *
   * Controllerからは以下の手順で使用できます。
   * メンバ visionSensor_ にセットされた ViewSimulator に対して、
   * 
   * -# ViewSimulator::getCameraSequenceOf を使用して Camera を取得します。
   * -# Camera::getCameraParameter から取得される CameraParameter で各種情報を調べます。
   *
   * 以下、シミュレーションループ
   *
   * -# Camera::getImageData で ImageDataを取得します。
   * -# このカメラのフォーマットにしたがい、ImageData::longData 等から画像を取得します。
   *
   * @author	Ichitaro Kohara, MSTC
   * @version	1.0(2001.02.22)
   * @else
   * Vision Sensor
   * @author	Ichitaro Kohara, MSTC
   * @version	1.0(2001.02.22)
   * @endif
   */
public class _ViewSimulatorStub extends org.omg.CORBA.portable.ObjectImpl implements jp.go.aist.hrp.simulator.ViewSimulator
{


  /**
       * @if jp
       * サーバを終了します。
       * @else
       * Destory
       * @endif
       */
  public void destroy ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("destroy", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                destroy (        );
            } finally {
                _releaseReply ($in);
            }
  } // destroy


  /**
       * @if jp
       * モデルを読み込みます。
       * @param src キャラクタのモデルファイルURL
       * @param objectName キャラクタ名
       * @else
       * Loat object
       * @param	src			object's URL
       * @param	objectName	object's Name
       * @endif
       */
  public void loadObject (String src, String objectName) throws jp.go.aist.hrp.simulator.ViewSimulatorPackage.ViewSimulatorException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("loadObject", true);
                $out.write_string (src);
                $out.write_string (objectName);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:OpenHRP/ViewSimulator/ViewSimulatorException:1.0"))
                    throw jp.go.aist.hrp.simulator.ViewSimulatorPackage.ViewSimulatorExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                loadObject (src, objectName        );
            } finally {
                _releaseReply ($in);
            }
  } // loadObject


  /**
       * @if jp
       * シミュレータにあるカメラを取得します。
       * @param cameras カメラ配列
       * @return カメラの台数
       * @else
       * Get cameras loaded in simulator
       * @param	cameras		cameras
       * @return	number of cameras
       * @endif
       */
  public void getCameraSequence (jp.go.aist.hrp.simulator.CameraSequenceHolder cameras)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCameraSequence", true);
                $in = _invoke ($out);
                cameras.value = jp.go.aist.hrp.simulator.CameraSequenceHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getCameraSequence (cameras        );
            } finally {
                _releaseReply ($in);
            }
  } // getCameraSequence


  /**
       * @if jp
       * キャラクタにあるカメラを取得します。
       * @param objectName キャラクタ名
       * @param cameras カメラ配列
       * @endif
       */
  public void getCameraSequenceOf (String objectName, jp.go.aist.hrp.simulator.CameraSequenceHolder cameras)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCameraSequenceOf", true);
                $out.write_string (objectName);
                $in = _invoke ($out);
                cameras.value = jp.go.aist.hrp.simulator.CameraSequenceHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getCameraSequenceOf (objectName, cameras        );
            } finally {
                _releaseReply ($in);
            }
  } // getCameraSequenceOf


  /**
       * @if jp
       * シーンを更新します。
       * @param state 新しい WorldState
       * @else
       * Update scene
       * @param	state	WorldState
       * @endif
       */
  public void updateScene (jp.go.aist.hrp.simulator.WorldState state)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("updateScene", true);
                jp.go.aist.hrp.simulator.WorldStateHelper.write ($out, state);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                updateScene (state        );
            } finally {
                _releaseReply ($in);
            }
  } // updateScene

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/ViewSimulator:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _ViewSimulatorStub
